package dev.shadowsoffire.apotheosis.ench.table;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.mojang.datafixers.kinds.App;
import com.mojang.datafixers.kinds.Applicative;
import com.mojang.datafixers.util.Function4;
import com.mojang.serialization.Codec;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import dev.shadowsoffire.apotheosis.ench.table.EnchantingStatRegistry;
import dev.shadowsoffire.placebo.codec.CodecProvider;
import dev.shadowsoffire.placebo.codec.PlaceboCodecs;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Optional;
import net.minecraft.core.Holder;
import net.minecraft.core.registries.Registries;
import net.minecraft.tags.TagKey;
import net.minecraft.world.level.block.Block;
import net.minecraftforge.registries.ForgeRegistries;

public class BlockStats implements CodecProvider<EnchantingStatRegistry.BlockStats> {
  public static Codec<BlockStats> CODEC;
  
  static {
    CODEC = RecordCodecBuilder.create(inst -> inst.group((App)PlaceboCodecs.nullableField(Codec.list(ForgeRegistries.BLOCKS.getCodec()), "blocks", Collections.emptyList()).forGetter(()), (App)PlaceboCodecs.nullableField(TagKey.m_203877_(Registries.f_256747_), "tag").forGetter(()), (App)PlaceboCodecs.nullableField(ForgeRegistries.BLOCKS.getCodec(), "block").forGetter(()), (App)EnchantingStatRegistry.Stats.CODEC.fieldOf("stats").forGetter(())).apply((Applicative)inst, dev.shadowsoffire.apotheosis.ench.table.EnchantingStatRegistry.BlockStats::new));
  }
  
  public final List<Block> blocks = new ArrayList<>();
  
  public final EnchantingStatRegistry.Stats stats;
  
  public BlockStats(List<Block> blocks, Optional<TagKey<Block>> tag, Optional<Block> block, EnchantingStatRegistry.Stats stats) {
    if (!blocks.isEmpty())
      this.blocks.addAll(blocks); 
    if (tag.isPresent())
      this.blocks.addAll(EnchantingStatRegistry.access$000(EnchantingStatRegistry.INSTANCE).getTag(tag.get()).stream().map(Holder::m_203334_).toList()); 
    if (block.isPresent())
      this.blocks.add(block.get()); 
    this.stats = stats;
  }
  
  public Codec<? extends BlockStats> getCodec() {
    return CODEC;
  }
}
